/*
 * FileZipDB.java
 *
 * Created on 2001/05/27, 10:13
 */

package HiroTools;

/**
 *
 * @author  Mitsuhiro Shirai
 * @version 1.0
 */

import java.lang.*;
import java.util.*;
import java.io.*;

/** f[^x[X𗘗pȂŒʏt@C𗘗pԍcaNX
 * ۃNX ZipDB ̎
 */
public class FileZipDB extends HiroTools.ZipDB {
    
    /** ԍcaCfbNXt@C */    
    public  static final String ZipIndexName = new String("ZipDB.IDX");
    /** ԍcaf[^t@C */    
    public  static final String ZipDataName  = new String("ZipDB.DAT");
    
    /** ԍcat@Cicat@Cj
     */    
    protected RandomAccessFile mFile = null;
        
    /** ԍCfbNXe[u
     */    
    public Vector mIndex = null;

    /** Pf[^̃R[h
     */    
    protected int mRecLength = -1;

    /** Creates new FileZipDB */
    public FileZipDB() {
    }

    /** NX̏@I mIsInitial=true ɂȂ
     * @param inParams p[^̐
     * @param inParam p[^
     */    
    public void Initial(int inParams,String[] inParam) {
        // cat@C̃t@CpXoI[v
        if (inParams == 2)  {
            try {
               
                // CfbNXꊇǍ
                RandomAccessFile    theFileIdx = new RandomAccessFile(inParam[0],"r");
                mDataCount = (int)(theFileIdx.length() / 7);
                mIndex = new Vector((int)mDataCount);
                byte    theBuff[] = new byte[7];
                for (int i=0;i<mDataCount;i++) {
                    theFileIdx.readFully(theBuff);
                    mIndex.add(new String(theBuff));
                }
                theFileIdx.close();
                theBuff = null;
               
                // f[^t@C̏
                mFile = new RandomAccessFile(inParam[1],"r");
                
                // PR[h̃f[^vZ
                mRecLength = (int)(mFile.length() / mDataCount);
                
                // ɏݒ芮
                mIsInitial = true;
            }
            catch (IOException e)    {
                System.out.print("Error :"+e);
                e.printStackTrace();
            }
        }        
    }

    /** f[^x[Xւ̐ڑ@ڑł mIsVarid=true ɂȂ
     * @return ڑ=true
     */    
    public boolean Connect() {
        // Ƃɂ邱Ƃ͂ȂBInitialIĂOK
        mIsVarid = mIsInitial;
        return mIsVarid;
    }
    
    /** f[^x[X̐ؒf mIsVarid=false ɂȂ
     */    
    public void Disconnect() {
        mIsVarid = false;
    }

    /** oCglTCintlɕύX
     * @param inByte oCgl
     * @return TC̃oCgl
     */    
    protected int UByte(byte inByte) {
        int result = (int)inByte;
        if (result < 0) result = 0x100 + result;
        return result;
    }

    /** w肵R[hV[PXԍ́ԍf[^擾
     * @param inIndexNo R[hV[PXԍ
     * @return ԍf[^IuWFNg
     */    
    public ZipData GetZipData(int inIndexNo)   {
       if (!mIsVarid || !mIsInitial || mRecLength < 0)  return null;      // ԕ
       ZipData theZipData = null;
            byte    theBuff[] = new byte[mRecLength];
           String theParam[] = new String[9];
        try {
            mFile.seek((long)(inIndexNo * mRecLength));
            mFile.readFully(theBuff);
            char theFlgs = (char)theBuff[19];       // etO
            theFlgs <<= 8;
            theFlgs += (char)theBuff[18];
            theParam[0] = new String(theBuff,0,5);  // Snc̃R[h
            theParam[1] = new String(theBuff,5,7);  // X֔ԍ(7)
            theParam[2] = new String(theBuff,12,5); //  X֔ԍ(5)
            int theOffset = 26;
            int thePos    = UByte(theBuff[20]);
            theParam[3] = new String(theBuff,theOffset,thePos); // s{ij [Əij]
            theOffset += thePos;
            thePos    = UByte(theBuff[21]);
            theParam[4] = new String(theBuff,theOffset,thePos); // s撬ij [s{ij]
            theOffset += thePos;
            thePos    = UByte(theBuff[22]);
            theParam[5] = new String(theBuff,theOffset,thePos); // 於@@ij [s撬ij]
            theOffset += thePos;
            thePos    = UByte(theBuff[23]);
            theParam[6] = new String(theBuff,theOffset,thePos); // s{ij [於ij]
            theOffset += thePos;
            thePos    = UByte(theBuff[24]);
            theParam[7] = new String(theBuff,theOffset,thePos); // s撬ij [AځAԒnij]
            theOffset += thePos;
            thePos    = UByte(theBuff[25]);
            theParam[8] = new String(theBuff,theOffset,thePos); // 於@@ij [ƏiJij]
            theZipData = new ZipData(theParam,theFlgs);         // ԍf[^IuWFNg쐬
            theBuff = null;
            theParam = null;
        }
        catch (Exception e)    {
            theZipData = null;
            e.printStackTrace();
        }
        return theZipData;
    }
     
    /** f[^x[X
     * @param inZipNo ԍiOvȂ̂Ō͏ȗ\j
     * @param inAddress Zivj
     * @return iI[o[t[̏ꍇ͍ő匏{PƂȂj
     */    
    public int DoFind(String inZipNo,String inAddress) {
        
        if (!mIsVarid || !mIsInitial)  return -1;      // ԕ
        
        // ʃe[ȕ
        mIndexNos.clear();
        
        // ʒmIuWFNgփX^[gʒm
        if (mInformationListeners != null)  mInformationListeners.StartInfor();
        
        // fobOp
        int theFindCount = 0;
        int theCount = mIndex.size();
        double  theValue;
        boolean isZipNo = (inZipNo != null   && inZipNo.length()   > 0);
        boolean isAddr  = (inAddress != null && inAddress.length() > 0);
        boolean isZipNoFindOn = false;      // Xs[hAbv̂߁A[Ώۃf[^łȂȂ炻ŏI
        for (int i=0;i<theCount;i++) {
                        
            // ʒmIuWFNg֏o߂ʒm
            if (mInformationListeners != null)  {
                theValue = i * mInformationListeners.GetScale() / theCount;
                if (!mInformationListeners.ProcessInfor((int)theValue)) {
                    // f˗
                    break;
                }
            }

            if (theFindCount > mFindMax)    {
                // I[o[t[
                break;
            }
            else    {
                
                // 
                if (isZipNo)    {
                    // ԍ̎w肪ꍇ
                    String  theZipNo = (String)mIndex.get(i);
                    if (theZipNo.startsWith(inZipNo))   {
                        // ԍOv
                        isZipNoFindOn = true;
                    }
                    else    {
                        // ԍsv
                        if (isZipNoFindOn)  {
                            // ͔ԍV[PXɂȂł̂łȏTĂ
                            break;
                        }
                        // ̔ԍ
                        continue;
                    }
                }
                
                if (isAddr) {
                    // Z̎w肪ꍇ
                    boolean isHit = false;
                    ZipData theZipData = GetZipData(i);
                    if ((theZipData == null) || !theZipData.Find(inAddress))    {
                        // ̔ԍ
                        continue;
                    }
                }
                
                // ܂łǂ蒅΁Ãf[^͒TĂf[^
                mIndexNos.add(new Integer(i));
                theFindCount++;
                
                // ʒmIuWFNg֌f[^ʒm
                if (mInformationListeners != null)  {
                    mInformationListeners.PregressInfor(new Integer(i));
                }
            }
            
        } // for i

        // ʒmIuWFNg֊ʒm
        if (mInformationListeners != null)  mInformationListeners.FinalInfor();
        
        return theFindCount;
    }
    
}

