/*
 * Preference.java
 *
 * Created on 2001/06/15, 13:24
 */

package HiroTools;

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;

/**
 *
 * @author  Mitsuhiro Shirai
 * @version 1.0
 */
public class Preference extends Object {
    
    /** ۑ}bv */
    private HashMap mPrefMap = new HashMap();
    
    /** ۑ鏉ݒt@C */
    private String mPrefFileName;
    
    /** f[^敪 (L[̃vtBbNXɂȂ) */
    public  static final String    IS_INT       = new String("Int_");
    public  static final String    IS_DIMENSION = new String("Dim_");
    public  static final String    IS_RECTANGLE = new String("Rct_");
    public  static final String    IS_STRING    = new String("Str_");
    
    /** RXgN^
     * @param inPrefFineName ݒt@C
     */
    public Preference(String inPrefFineName) {
        // t@Cۑ
        mPrefFileName = new String(inPrefFineName);
    }
    
    /** lϊ
     * @param inPrefFineName ݒt@C
     */
    private Integer atoInteger(String inStr)  {
        Integer theNum = null;
        try {
            theNum = new Integer(inStr);
            int num = theNum.intValue();
        }
        catch (Exception e)    {
            theNum = null;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return theNum;
    }
    
    /** ݒt@CǍݓ̃}bvݒ
     * @return I true
     */    
    public  boolean LoadPref() {
        mPrefMap.clear();
        boolean    result = false;
        try {
            BufferedReader thePrefFile = new BufferedReader(new FileReader(mPrefFileName));
            String  theBuff;
            while ((theBuff = thePrefFile.readLine()) != null)    {
                StringTokenizer theToken = new StringTokenizer(theBuff,"=");
                if (theToken.countTokens() == 2)    {
                    String  theKeyStr = theToken.nextToken();
                    String  theParam  = theToken.nextToken();
                    StringTokenizer theParmToken = new StringTokenizer(theParam,",");
                    // 敪
                    if       (theKeyStr.startsWith(IS_INT))   {
                        // lip^Pj
                        if (theParmToken.countTokens() >= 1)    {
                            mPrefMap.put(theKeyStr.substring(IS_INT.length(),theKeyStr.length()),
                                        atoInteger(theParmToken.nextToken()));
                        }
                    }
                    else if (theKeyStr.startsWith(IS_DIMENSION))   {
                        // TCYip^Qj
                        if (theParmToken.countTokens() >= 2)    {
                            Integer width  = atoInteger(theParmToken.nextToken());
                            Integer height = atoInteger(theParmToken.nextToken());
                            if (height != null && width != null)    {
                                 mPrefMap.put(theKeyStr.substring(IS_DIMENSION.length(),theKeyStr.length()),
                                        new Dimension(width.intValue(),height.intValue()));
                            }
                        }
                    }
                    else if (theKeyStr.startsWith(IS_RECTANGLE))   {
                        // `ip^Sj
                        if (theParmToken.countTokens() >= 4)    {
                            Integer x      = atoInteger(theParmToken.nextToken());
                            Integer y      = atoInteger(theParmToken.nextToken());
                            Integer width  = atoInteger(theParmToken.nextToken());
                            Integer height = atoInteger(theParmToken.nextToken());
                            if (x != null && y != null && height != null && width != null)    {
                                mPrefMap.put(theKeyStr.substring(IS_RECTANGLE.length(),theKeyStr.length()),
                                        new Rectangle(x.intValue(),y.intValue(),
                                                        width.intValue(),height.intValue()));
                            }
                        }
                    }
                    else if (theKeyStr.startsWith(IS_STRING))   {
                        // ip^Pj
                        if (theParmToken.countTokens() >= 1)    {
                           mPrefMap.put(theKeyStr.substring(IS_STRING.length(),theKeyStr.length()),
                                        theParmToken.nextToken());
                        }
                    }
                }
            }
            thePrefFile.close();
            result = true;
        }
        catch (Exception e)    {
            result = false;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return result;
    }
    
    /** ̃}bvݒt@C֏o
     * @return I true
     */    
    public  boolean SavePref()  {
        Iterator    theIter = mPrefMap.entrySet().iterator();
        if (theIter == null)    return false;
        
        boolean    result = false;
         try {
           Map.Entry    theEntry;
           String       theKeyStr;
           Object       theValue;
           StringBuffer theBuff;
           PrintWriter thePrefFile = new PrintWriter(new FileWriter(mPrefFileName));
           while (theIter.hasNext()) {
                // L[o
                theEntry = (Map.Entry)theIter.next();
                theKeyStr = (String)theEntry.getKey();
                theValue  = theEntry.getValue();
                // 敪
                if       (theValue.getClass().getName().equalsIgnoreCase("java.lang.Integer"))   {
                    // l
                    Integer   theInt = (Integer)theValue;   
                    theBuff = new StringBuffer(IS_INT);
                    theBuff.append(theKeyStr);
                    theBuff.append("=");
                    theBuff.append(theInt.intValue());
                    theBuff.append("\r");
                    thePrefFile.print(theBuff);
                 }
                else if (theValue.getClass().getName().equalsIgnoreCase("java.awt.Dimension"))   {
                    // TCY
                    Dimension   theDim = (Dimension)theValue;
                    theBuff = new StringBuffer(IS_DIMENSION);
                    theBuff.append(theKeyStr);
                    theBuff.append("=");
                    theBuff.append(theDim.width);
                    theBuff.append(",");
                    theBuff.append(theDim.height);
                    theBuff.append("\r");
                    thePrefFile.print(theBuff);
                }
                else if (theValue.getClass().getName().equalsIgnoreCase("java.awt.Rectangle"))   {
                    // `
                    Rectangle   theRect = (Rectangle)theValue;
                    theBuff = new StringBuffer(IS_RECTANGLE);
                    theBuff.append(theKeyStr);
                    theBuff.append("=");
                    theBuff.append(theRect.x);
                    theBuff.append(",");
                    theBuff.append(theRect.y);
                    theBuff.append(",");
                    theBuff.append(theRect.width);
                    theBuff.append(",");
                    theBuff.append(theRect.height);
                    theBuff.append("\r");
                    thePrefFile.print(theBuff);
                }
                else if (theValue.getClass().getName().equalsIgnoreCase("java.lang.String"))   {
                    // 
                    String   theStr = (String)theValue;
                    theBuff = new StringBuffer(IS_STRING);
                    theBuff.append(theKeyStr);
                    theBuff.append("=");
                    theBuff.append(theStr);
                    theBuff.append("\r");
                    thePrefFile.print(theBuff);
                }
            }
            thePrefFile.close();
            result = true;
        }
        catch (Exception e)    {
            result = false;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return result;
    }
    
    /** lo
     * @param inKey L[
     * @return ol
     */    
    public Integer GetInt(String inKey) {
        Integer theInt = null;
        try {
            Object  theObj = mPrefMap.get(inKey);
            if (theObj != null && 
                    theObj.getClass().getName().equalsIgnoreCase("java.lang.Integer"))    {
                theInt = new Integer(((Integer)theObj).intValue());
            }
        }
        catch (Exception e)    {
            theInt = null;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return theInt;
    }
    
    /** lݒ
     * @param inKey L[
     * @param inNum ݒ肷鐔l
     * @return I true
     */    
    public boolean PutInt(String inKey,int inNum) {
        boolean result = false;
        mPrefMap.remove(inKey);     // ÂGg[폜
        try {
            mPrefMap.put(inKey,new Integer(inNum));
            result = true;
        }
        catch (Exception e)    {
            result = false;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return result;
    }
    
    /** TCYo
     * @param inKey L[
     * @return oTCY
     */    
    public Dimension GetDimension(final String inKey) {
        Dimension theDim = null;
        try {
            Object  theObj = mPrefMap.get(inKey);
            if (theObj != null && 
                    theObj.getClass().getName().equalsIgnoreCase("java.awt.Dimension"))    {
                theDim = new Dimension((Dimension)theObj);
            }
        }
        catch (Exception e)    {
            theDim = null;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return theDim;
    }
    
    /** TCYݒ
     * @return I true
     * @param inKey L[
     * @param Dimension ݒ肷TCY  
     */    
    public boolean PutDimension(String inKey,Dimension inDimension) {
        boolean result = false;
        mPrefMap.remove(inKey);     // ÂGg[폜
        try {
            mPrefMap.put(inKey,inDimension);
            result = true;
        }
        catch (Exception e)    {
            result = false;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return result;
    }
    
    /** `o
     * @param inKey L[
     * @return o`
     */    
    public Rectangle GetRectangle(String inKey) {
        Rectangle theRect = null;
        try {
            Object  theObj = mPrefMap.get(inKey);
            if (theObj != null && 
                    theObj.getClass().getName().equalsIgnoreCase("java.awt.Rectangle"))    {
                theRect = new Rectangle((Rectangle)theObj);
            }
        }
        catch (Exception e)    {
            theRect = null;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return theRect;
    }
    
    /** `ݒ
     * @param inKey L[
     * @param inRectangle ݒ肷`
     * @return I true
     */    
    public boolean PutRectangle(String inKey,Rectangle inRectangle) {
        boolean result = false;
        mPrefMap.remove(inKey);     // ÂGg[폜
        try {
            mPrefMap.put(inKey,inRectangle);
            result = true;
        }
        catch (Exception e)    {
            result = false;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return result;
    }
    
    /** o
     * @param inKey L[
     * @return o
     */    
    public String GetString(String inKey) {
        String theStr = null;
        try {
            Object  theObj = mPrefMap.get(inKey);
            if (theObj != null && 
                    theObj.getClass().getName().equalsIgnoreCase("java.lang.String"))    {
                theStr = new String((String)theObj);
            }
        }
        catch (Exception e)    {
            theStr = null;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return theStr;
    }
    
    /** ݒ
     * @param inKey L[
     * @param inString ݒ肷镶
     * @return I true
     */    
    public boolean PutString(String inKey,String inString) {
        boolean result = false;
        mPrefMap.remove(inKey);     // ÂGg[폜
        try {
            mPrefMap.put(inKey,inString);
            result = true;
        }
        catch (Exception e)    {
            result = false;
            System.out.print("Error :"+e);
            e.printStackTrace();
        }
        return result;
    }
    
}
